indexing

	description:

		"Eiffel actual generic parameters which appear in a comma-separated list of parameters"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 2003-2006, Eric Bezault and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2006/03/09 11:36:26 $"
	revision: "$Revision: 1.2 $"

deferred class ET_ACTUAL_PARAMETER_ITEM

inherit

	ET_AST_NODE

feature -- Access

	actual_parameter: ET_ACTUAL_PARAMETER is
			-- Actual parameter in comma-separated list
		deferred
		ensure
			actual_parameter_not_void: Result /= Void
		end

	type: ET_TYPE is
			-- Type of `actual_parameter'
		deferred
		ensure
			type_not_void: Result /= Void
		end

	label: ET_IDENTIFIER is
			-- Label of `actual_parameter';
			-- Useful when part of a labeled tuple, Void if no label
		deferred
		end

feature -- Type processing

	resolved_formal_parameters_with_type (a_type: ET_TYPE): ET_ACTUAL_PARAMETER_ITEM is
			-- Version of current actual parameter where its type
			-- is replaced by `a_type'
		require
			a_type_not_void: a_type /= Void
		deferred
		ensure
			resolved_formal_parameters_not_void: Result /= Void
		end

end
